
// FILE: strStuff.cpp

#include <iostream.h>
#include <exception.h>
#include "strStuff.h"

static void strCopy2(char *s1, char *s2);
static int str2int(char *s);

void testStr()
{
	char s1[] = "Hello World!";
	char s2[13];
	strCopy2(s1, s2);
	cout << s2 << endl;
	
	char s[256]; // inherently dangerous
	cout << "Enter a number: ";
	cin >> s;
	try {
		cout << s << " = " << str2int(s) << endl;
	} catch (xmsg &err) {
		cerr << "Exception: " << err.why() << endl;
	}
}

void strCopy(char s1[], char s2[])
{
	int i=0;
	while (s1[i] != '\0') {
		s2[i] = s1[i];
		i++;
	}
	s2[i] = '\0';
}

void strCopy2(char *s1, char *s2)
{
	while (*s2++ = *s1++);
}

int str2int(char *s)
{
	int value = 0;
	while (*s != '\0') {
		int digit = *s++ - '0';
		if ((digit<0) || (digit>9)) {
			throw(xmsg("str2int: argument not an int!"));
		}
		value = 10*value + digit;
	}
	return value;
}
