
/*
	fact.C -- factorials using lazy lists
*/

#include <iostream.h>

// #include <assert.h>
// #include <vector.h>
// #include <algo.h>

#include "lazy.h"

#define DEBUG

typedef LazyList<int> LazyIntList;
// typedef LazyList LazyIntList;

int computeFact(int n, LazyIntList& factList);
LazyIntList fact(computeFact);

void factTest(void);

int main(void)
{
	// threeTest();
	factTest();
	return 0;
}

void factTest(void)
{
	cout << "fact(5) = " << fact(5) << endl;
	cout << "fact(3) = " << fact(3) << endl;
	cout << "fact(10) = " << fact(10) << endl;
	cout << "fact(8) = " << fact(8) << endl;
	// fact.print();
}

int
computeFact(int n, LazyIntList& factList)
{
#ifdef DEBUG
	cerr << "computing fact(" << n << ")" << endl;
#endif
	if (n == 0)
		return 1;
	else
		return n*factList(n-1);
}

