/*
	Line reverser in Java ...
*/

/*
public class JRev {
	public static void main(String args[]) {
		new RevCommand(args);
	}
}
*/

import java.io.*; // for DataInputStream etc.
import java.util.*; // for Stack, EmptyStackException

public class JRev {
	public static void main(String args[]) {
		rev(System.in);
	}
	public static void rev(InputStream in) {
		try {
			DataInput ds = new DataInputStream(in);
			String s = null;
			Stack stack = new Stack();
			while ((s = ds.readLine()) != null) {
				stack.push(s);
			}
			while (!stack.empty()) {
				System.out.println((String) stack.pop());
			}
		} catch (EmptyStackException err) { }
		catch (IOException err) { }
		System.out.flush();
	}
}

