
/*
	File: arev.cpp
	(c) Oscar Nierstrasz 30.3.96
*/

#include <iostream.h>
#include <exception.h>

#include "AStack.h"
#include "String.h"

typedef AStack<String> IOStack;

int main(void)
{
	IOStack ioStack;
	String buf;

	try {
		while (buf.getline(cin)) {
			ioStack.push(buf);
		}

		while (ioStack.count() != 0) {
			cout << ioStack.top() << endl;
			ioStack.pop();
		}
	}
	catch (xmsg &err) {
		cout << "Exception: " << err.why() << endl;
		return -1;
	}
	return 0;
}

