
/*
	A recursive C implementation of the line reverser program.
*/

#include <stdlib.h>
#include <stdio.h>

const int bufSize = 256;

void recrev(void);
int getline(int, char*);

int main (void)
{
	recrev();
	return 0;
}

void recrev()
{
	char buf[bufSize];
	/*
	if (scanf("%256s", buf) != EOF) {
	*/
	if (getline(bufSize, buf) != EOF) {
		recrev();
		printf("%s\n", buf);
	}
}

int getline(int len, char *buf)
{
	int l=0;
	char c;
	while ((c = getchar()) != EOF) {
		if (l>len) {
			fprintf(stderr, "frev: buffer overflow!!!\n");
			exit(-1);
		}
		if (c == '\n') {
			buf[l++] = '\0';
			return 0;
		}
		else {
			buf[l++] = c;
		}
	}
	return EOF;
}

